//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//+------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_style2  STYLE_DOT
#property indicator_minimum  -1
#property indicator_maximum 101
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame      = PERIOD_CURRENT; // Time frame to use
extern int                RsqPeriod      = 14;             // R-squared period
extern ENUM_APPLIED_PRICE RsqPrice       = PRICE_CLOSE;    // Price  
extern int                RsqAverage     = 14;             // R-squared average period
extern ENUM_MA_METHOD     RsqAverageMode = MODE_SMA;       // R-squared average method
extern bool               Interpolate    = true;           // Interpolate in multi time frame mode?

double rsq[];
double rsqavg[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,rsq);
   SetIndexBuffer(1,rsqavg);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
      IndicatorShortName(timeFrameToString(TimeFrame)+" R-Squared "+(string)RsqPeriod+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int countedBars = IndicatorCounted();
      if (countedBars<0) return(-1);
      if (countedBars>0) countedBars--;
         int limit = MathMin(Bars-countedBars,Bars-1);
         if (returnBars) { rsq[0] = MathMin(limit+1,Bars-1); return(0); }
   
   //
   //
   //
   //
   //
   
   if (TimeFrame == _Period)
   {
      for(int i=limit; i>=0; i--) rsq[i]    = iRsq(iMA(NULL,0,1,0,MODE_SMA,RsqPrice,i),RsqPeriod,i);
      for(int i=limit; i>=0; i--) rsqavg[i] = iMAOnArray(rsq,0,RsqAverage,0,RsqAverageMode,i);
      return(0);
   }
   
   //
   //
   //
   //
   //

   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
   for (int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         rsq[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,RsqPeriod,RsqPrice,RsqAverage,RsqAverageMode,0,y);
         rsqavg[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,RsqPeriod,RsqPrice,RsqAverage,RsqAverageMode,1,y);
         if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
         //
         //
         //
         //
         //
                  
         int n,j; datetime time = iTime(NULL,TimeFrame,y);
           for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
           for(j = 1; j<n && (i+n)<Bars && (i+j)<Bars; j++)
           {
              rsq[i+j]    = rsq[i]    + (rsq[i+n]   -rsq[i]   )*j/n;
              rsqavg[i+j] = rsqavg[i] + (rsqavg[i+n]-rsqavg[i])*j/n;
           }                           
   }
   return(0);
}   


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workr[][1];
double iRsq(double price, double period, int i, int instanceNo=0)
{
   if (ArrayRange(workr,0) != Bars) ArrayResize(workr,Bars); i = Bars-i-1;
  
   //
   //
   //
   //
   //

      workr[i][instanceNo] = price;

         double SumX  = 0;
         double SumXX = 0;
         double SumXY = 0;
         double SumYY = 0;
         double SumY  = 0;
 
                  for(int k=0; k<period && (i-k)>=0; k++)
                  {
                     double tprice = workr[i-k][instanceNo];
                        SumX  += (k+1); 
                        SumXX += (k+1)*(k+1);
                        SumXY += (k+1)*tprice;
                        SumYY +=       tprice*tprice;
                        SumY  +=       tprice;
                  }
   
         double Q1  = SumXY - SumX*SumY/period;
         double Q2  = SumXX - SumX*SumX/period;
         double Q3  = SumYY - SumY*SumY/period;
         return(100.0*(Q1*Q1)/(Q2*Q3));
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}